setwd('C:/Users/Martijn/Desktop/TODO-USA/QITL/')
library(mgcv)
load('accents.rda')

iso = read.table('isocodes.txt',header=T,sep='\t')
dat = merge(accents,iso,by='Language')
meta = read.table('metadata.txt',header=T,sep='\t')
ld = read.table('engsimLDND.txt',header=T,sep='\t',quote='',fill=T)
tmp = merge(meta,ld,by='Lang')
#tmper = unique(tmp[,c("Iso","Lang","NrItem")])
#agg = aggregate(tmper$NrItem,by=list(tmper$Iso),FUN=max) # select corresponding languages with highest number of items
#colnames(agg)=c("Iso","NrItem")
#tmp2 = merge(tmp,agg,by=c("Iso","NrItem")) # exclude everything with too few elements
#tmp3 = aggregate(tmp2$LD2,by=list(tmp2$Iso),FUN=mean)
tmp3 = aggregate(tmp$LD2,by=list(tmp$Iso),FUN=mean)
colnames(tmp3) = c("Iso","LD2")
dat2 = merge(dat,tmp3,by='Iso')
dat = droplevels(dat2[dat2$IsNaturalLearner == 'FALSE',])
dat$LDND = 100 - dat$LD2

dat$AEO.c = scale(dat$AEO,scale=F)[1:712]
dat$CountryEduYrs.c = scale(dat$CountryEduYrs,scale=F)[1:712]
dat$NrLang.c = scale(dat$NrLang,scale=F)[1:712]
dat$LDND.c = scale(dat$LDND,scale=F)[1:712]
dat$GNI.log.c = scale(dat$GNI.log,scale=F)[1:712]
dat$LR.c = scale(dat$LR,scale=F)[1:712]
dat$Age.c = scale(dat$Age,scale=F)[1:712]
dat$NrLangNIE = NULL
dat$NrLangIE = NULL
dat$IsNaturalLearner = NULL
dat$PopSize.log = NULL
dat$ShiftedAEO = NULL
dat$PastBreakPoint = NULL
dat$LD2 = NULL
dat2 = dat[,c("Speaker","Language","Iso","Country","LD.log","Nativelikeness","IsIESpeaker","LDND", "Age","IsMale","AEO","LR","NrLang","GNI.log","CountryEduYrs","LDND.c","Age.c","AEO.c","LR.c","NrLang.c","GNI.log.c","CountryEduYrs.c")]
dat = dat2
accents = droplevels(dat)

pmi = read.csv('pmiDistsEnglish.csv',header=T)
pmi$ASJP = NULL
pmi2 = aggregate(pmi$PMI,by=list(pmi$iso),FUN=mean)
colnames(pmi2) = c("Iso","PMI")
accents2 = merge(pmi2,accents,by="Iso")
accents = accents2

dat = read.table('L04dist.txt',header=T,sep='\t')
#load('accents.rda')
accents2 = merge(dat,accents,by='Iso')
accents = accents2

accents2 = accents[,c(4,5,1,6,7,8,9,10,2,3,11:24)]
accents2$LDN.c = accents2$LDN - mean(accents2$LDN)
accents2$PMI.c = accents2$PMI - mean(accents2$PMI)
accents3 = accents2[,c(1:18,25,26,19:24)]
accents = accents3
save(accents,file='accents.rda')

#
summary(m0 <- gam(LD.log ~ AEO + IsIESpeaker + te(LR.c,Age.c) + CountryEduYrs + NrLang + s(Country,bs='re'), data=accents, method='ML'))
summary(m1 <- gam(LD.log ~ AEO + LDND + te(LR.c,Age.c) + CountryEduYrs + NrLang + s(Country,bs='re'), data=accents, method='ML'))
AIC(m0) - AIC(m1)
library(car)
qqp(resid(m0)) # 1 outlier at large end
dat2 = dat[resid(m0) < max(resid(m0)),]
 dat2$AEO.c = scale(dat2$AEO,scale=F)
 dat2$LDND.c = scale(dat2$LDND,scale=F)
 dat2$CountryEduYrs.c = scale(dat2$CountryEduYrs,scale=F)
 dat2$NrLang.c = scale(dat2$NrLang,scale=F)


summary(m1 <- gam(LD.log ~ LDND.c + AEO.c  + LR.c*Age.c+ CountryEduYrs.c + NrLang.c + s(Country,bs='re'), data=dat2, method='ML'))
summary(m1x <- gam(LD.log ~ LDND.c + AEO.c  + LR.c*Age.c+ CountryEduYrs.c + NrLang.c + s(Country,bs='re') + s(Language,bs='re'), data=dat2, method='ML'))
AIC(m1) - AIC(m1x)

coef(m1)["LDND.c"]*(max(dat2$LDND.c)-min(dat2$LDND.c))
coef(m1)["AEO.c"]*(max(dat2$AEO.c)-min(dat2$AEO.c))
coef(m1)["CountryEduYrs.c"]*(max(dat2$CountryEduYrs.c)-min(dat2$CountryEduYrs.c))
coef(m1)["NrLang.c"]*(max(dat2$NrLang.c)-min(dat2$NrLang.c))

mx = -Inf
mn = Inf
dat2$LR.c_Age.c = dat2$LR.c * dat2$Age.c
fx = coef(m1)
for (i in 1:nrow(dat2)) {
   val = fx["LR.c"]*dat2[i,"LR.c"] +
         fx["Age.c"]*dat2[i,"Age.c"] +
         fx["LR.c:Age.c"]*dat2[i,"LR.c_Age.c"]
   names(val) = "LR.c*Age.c"
   if (val < mn) {
      mn = val
   }
   if (val > mx) {
      mx = val
   }
}
round(mx - mn,3) # 0.24


# visualize interaction
library(itsadug)
summary(m1b <- gam(LD.log ~ LDND + AEO  + te(LR,Age)+ CountryEduYrs + NrLang + s(Country,bs='re'), data=dat2, method='ML'))
pvisgam(m1b,select=1,view=c('Age','LR'),too.far=0.04,hide.label=T,ylab='Length of residence', xlab='Age',main='')

summary(m1b <- gam(LD.log ~ LDND + AEO  + te(LR,Age)+ CountryEduYrs + NrLang + s(Country,bs='re'), data=dat2, method='REML'))
pvisgam(m1b,select=1,view=c('LR','Age'),too.far=0.04,hide.label=T,xlab='Length of residence', ylab='Age',main='')



# explained variance of model without random intercep
summary(m0 <- gam(LD.log ~ AEO.c + LDND.c + LR.c*Age.c+ CountryEduYrs.c + NrLang.c, data=dat2, method='ML'))

summary(m00 <- gam(LD.log ~  LDND.c, data=dat2, method='ML'))

summary(m2 <- gam(LD.log ~ te(AEO,LD2) + te(LR.c,Age.c) + CountryEduYrs + NrLang + s(Country,bs='re'), data=dat, method='ML'))


summary(m0n <- gam(Nativelikeness ~ AEO.c + IsIESpeaker + LR.c*Age.c + CountryEduYrs.c + NrLang.c + s(Country,bs='re'), data=dat2, method='ML'))
summary(m1n <- gam(Nativelikeness ~ AEO.c + LDND + LR.c*Age.c + CountryEduYrs.c + NrLang.c + s(Country,bs='re'), data=dat2, method='ML'))

AIC(m0n) - AIC(m1n)

summary(m0n <- gam(Nativelikeness ~ AEO + LDND + LR.c*Age.c + CountryEduYrs + NrLang, data=dat2, method='ML'))
summary(m0l <- gam(Nativelikeness ~ AEO + LDN + LR.c*Age.c + CountryEduYrs + NrLang, data=dat2, method='ML') # better


dat3 = droplevels(dat2[!is.na(dat2$Nativelikeness),])

coef(m0n)["AEO.c"]*(max(dat3$AEO.c)-min(dat3$AEO.c))
coef(m0n)["LDND.c"]*(max(dat3$LDND.c)-min(dat3$LDND.c))
coef(m0n)["CountryEduYrs.c"]*(max(dat3$CountryEduYrs.c)-min(dat3$CountryEduYrs.c))
coef(m0n)["NrLang.c"]*(max(dat3$NrLang.c)-min(dat3$NrLang.c))

mx = -Inf
mn = Inf
dat3$LR.c_Age.c = dat3$LR.c * dat3$Age.c
fx = coef(m1)
for (i in 1:nrow(dat3)) {
   val = fx["LR.c"]*dat3[i,"LR.c"] +
         fx["Age.c"]*dat3[i,"Age.c"] +
         fx["LR.c:Age.c"]*dat3[i,"LR.c_Age.c"]
   names(val) = "LR.c*Age.c"
   if (val < mn) {
      mn = val
   }
   if (val > mx) {
      mx = val
   }
}
round(mx - mn,3) # 0.24



summary(m00n <- gam(Nativelikeness ~ LDND, data=dat2, method='ML'))