#!/usr/bin/python
import re, collections

isocodes = ["eng","afb","afr","aka","als","amh","any","azj","bam","bax","bca","bel","ben","bfa","bgp","bin","bjt","bmi","bod","bos","bsp","bul","cal","cat","ces","ckb","cmn","dan","ddg","deu","dib","dyo","ell","ewe","fak","fij","fin","fmp","fra","fry","fub","fuc","gaa","gaz","gsw","guj","guz","hau","hdy","heb","hin","hrv","hun","hye","ibo","ind","isl","ita","jpn","kan","kao","kat","kaz","khk","khm","kik","kin","kir","knc","knf","knn","kor","kri","ktb","kwy","lao","lit","lug","luo","lvs","mal","mar","men","mfe","mfq","mkd","mlt","mnk","mos","mya","nan","naq","niq","nld","nor","npi","nya","ory","pbt","pes","pnb","pnr","pol","pon","por","prs","quh","ron","rtm","rus","sdn","shk","sin","slk","slp","slv","sna","som","sot","spa","srp","srr","sun","sus","swe","swh","tam","tat","tdt","tel","tgl","tha","thz","tir","tpi","tsn","tur","uig","ukr","urd","uzn","vie","woe","wof","yap","ydd","yor","yue","zlm","zul"]
words40 = ["1","2","3","11","12","18","19","21","22","23","25","28","30","31","34","39","40","41","43","44","47","48","51","53","54","57","58","61","66","72","74","75","77","82","85","86","92","95","96","100"]

d = collections.defaultdict(dict)
for ic in isocodes:
    for wordnr in words40:
        d[ic][wordnr] = "" 

lst = open('listss16.txt','r')
tokens = set()
tokens2 = set()
tokens3 = set()
tokens4 = set()

proc = False
for line in lst:
    if line.startswith(' '): # read iso code (last item)
        itms = line.split(' ')
        iso = itms[len(itms)-1].strip()
        if iso in isocodes:
            proc = True
        else: 
            proc = False
    elif proc and not line[0].isalpha(): # if iso code occurs in data 
        itms = re.split('//|\t',line)
        num = itms[0].split(' ')[0]
        if num in words40: # only word if in list
            trans = itms[1].replace(' ','').replace(',',' / ').strip() # make string of all
            subtrans = trans.split(' / ')
            for subt in subtrans:
                m = re.search('(..~)',subt)
                if m:
                    tokens.add(m.group(1))
                
                m2 = re.search('(...\$)',subt)
                if m2:
                    tokens2.add(m2.group(1))
                
                m3 = re.search('(.")',subt)
                if m3:
                    tokens3.add(m3.group(1))
                
                m4 = re.search('(.\*)',subt)
                if m4:
                    tokens4.add(m4.group(1))

            if trans != "XXX":
                if d[iso][num] != "":
                    d[iso][num] = d[iso][num] + ' / ' + trans
                else:
                    d[iso][num] = trans




outfile = open('asjp.txt','w')
outfile.write("\tI\tyou\twe\tone\ttwo\tperson\tfish\tdog\tlouse\ttree\tleaf\tskin\tblood\tbone\thorn\tear\teye\tnose\ttooth\ttongue\tknee\thand\tbreast\tliver\tdrink\tsee\thear\tdie\tcome\tsun\tstar\twater\tstone\tfire\tpath\tmountain\tnight\tfull\tnew\tname\n")
for ic in isocodes:
    outfile.write(ic)
    for wordnr in words40:
        outfile.write('\t' + d[ic][wordnr])
    outfile.write('\n')


#outfile2 = open('tokensets.txt','w')
#cnter = 100
#for t in tokens:
#    outfile2.write("H " + t + "\nT consonant\nF id = " + str(cnter) + "\n\n")
#    cnter += 1
#
#for t in tokens2:
#    outfile2.write("H " + t + "\nT consonant\nF id = " + str(cnter) + "\n\n")
#    cnter += 1
#
#for t in tokens3:
#    outfile2.write("H " + t + "\nT consonant\nF id = " + str(cnter) + "\n\n")
#    cnter += 1
#
#for t in tokens4:
#    outfile2.write("H " + t + "\nT vowel\nF id = " + str(cnter) + "\n\n")
#    cnter += 1